/* Copyright (c) 1993-1996 Argonaut Technologies Limited. All rights reserved.
 *
 * $Id: harness.c 1.1 1996/09/17 12:32:50 NIKH Exp $
 * $Locker: $
 *
 * Generic test harness framework
 */

/*
 * BRender headers
 */
#include "brender.h"
#include "dosio.h"

/*
 * Generic header
 */
#include "harness.h"
#include "support.h"

/*
 * main screen (device)
 */
extern br_pixelmap *screen;

/*
 * back screen
 */
extern br_pixelmap *back_screen;

/*
 * sample harness function table
 */
extern _sample_fn_list *_sample_fn_table;
br_uint_8 debug = 1;

br_uint_32 *bucket[2];

void main(void) {

	br_int_32 frame_mode;	/* frame mode for VSync */
	br_uint_32 time, max_time;
	
	int count;
	max_time = 0;
	time = 0;

	/*
         * init DOS Gfx, BRender
	 */
	frame_mode = _sample_fn_table->sample_init_device();

	/*
	 * setup data structures
	 */
	_sample_fn_table->sample_init_world();

	/*
	 * inner loop, terminated by sample_loop_test() returning -1
	 */
	while(_sample_fn_table->sample_loop_test() != -1) {

	    	/*
                 * generic pad test (keyboard/mouse for PC)
		 */
		_sample_fn_table->sample_pad_test();

		/*
		 * update data structures
		 */
		_sample_fn_table->sample_update_fn();

		/*
		 * render world
		 */
		_sample_fn_table->sample_render_fn();

		count = 1; /* root */

		BrActorEnum(root, ActorEnumCbfn, &count);

                /*
		 * align double buffer swap
		 */
		{
		}

		_sample_fn_table->sample_double_buffer();
	}

	/*
	 * terminate sample
	 */
	_sample_fn_table->sample_term();
}

