/* Copyright (c) 1993-1996 Argonaut Technologies Limited. All rights reserved.
 *
 * $Id: HARNESS.H 1.1 1996/09/12 14:01:11 NIKH Exp $
 * $Locker: $
 *
 * PS Generic test harness
 */

/*
 * main screen (device)
 */
extern br_pixelmap *screen;

/*
 * double buffer back screens
 */
extern br_pixelmap *back_screen;

typedef br_int_8 _sample_fn(void);

/*
 * test harness generic functions
 */
typedef struct _sample_fn_list {

	 _sample_fn *sample_init_device;	/* init PS hardware, BRender, PSGfx */
	 _sample_fn *sample_init_world;		/* init data structures */
	 _sample_fn *sample_render_fn;		/* rendering function */
	 _sample_fn *sample_double_buffer;	/* double buffer function */
	 _sample_fn *sample_update_fn;		/* update world */
	 void *sample_double_buffer_cbfn;	/* double buffer callback */
	 _sample_fn *sample_loop_test;		/* loop decision */
	 _sample_fn *sample_pad_test;		/* joypad */
	 _sample_fn *sample_term;		/* terminate sample (shut down BRender, PSGfx */
    
} _sample_fn_list;

/*
 * generic function table
 */
extern _sample_fn_list *_sample_fn_table;

#define PAD_UP		PADLup
#define PAD_DOWN	PADLdown
#define PAD_LEFT	PADLleft
#define PAD_RIGHT	PADLright
#define	PAD_TRI		PADRup
#define PAD_CROSS	PADRdown
#define PAD_SQUARE	PADRleft
#define PAD_CIRCLE	PADRright
#define PAD_FRONT_LTOP	PADn
#define PAD_FRONT_LBOT	PADo
#define PAD_FRONT_RTOP	PADl
#define PAD_FRONT_RBOT	PADm
#define PAD_SELECT	PADk
#define PAD_START	PADh

#define PAD_COMPARE(a,b) ((a & b)?1:0)


#ifdef __PS__
#ifdef _NTSC
#define HBL_PER_VBL	262
#define VBL_PER_SEC	60
#else
#define HBL_PER_VBL	315
#define VBL_PER_SEC	50
#endif
#endif

